#include <iostream>
#include <vector>
#include <iomanip>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    
    long long N, Q;
    cin >> N >> Q;

    vector<pair<long long, long long>> kupovine(N);
    for (long long i = 0; i < N; ++i) {
        cin >> kupovine[i].first >> kupovine[i].second;
    }

    vector<long long> upiti(Q);
    for (long long i = 0; i < Q; ++i) {
        cin >> upiti[i];
    }

    vector<long long> rezultati(Q);

    for (long long i = 0; i < Q; ++i) {
        long long k = upiti[i];
        long long ukupno_keksa = 0;

        for (long long j = 0; j < N; ++j) {
            if (kupovine[j].first < k) {
                ukupno_keksa += kupovine[j].second;
            } else {
                break;
            }
        }

        long long dani_posle_poslednje_kupovine = k - 1;
        long long ukupno_pojedenih = min(ukupno_keksa, dani_posle_poslednje_kupovine);

        rezultati[i] = ukupno_pojedenih;
    }

    for (long long rezultat : rezultati) {
        cout << rezultat << endl;
    }

    return 0;
}